%{
open Ast
%}

%start program

%type <Ast.truthtable * Ast.formula> program
%type <Ast.truthtable> table table2
%type <Ast.formula> formula
%type <Ast.constant> constant

%token LLParen LRParen LEq LTrue LFalse LOr LAnd LNot LImplies LIff LEof
%token <string> LVar
%%

constant:
  LTrue  { True }
| LFalse { False }

table:
  LLParen LRParen { [] }
| LLParen table2 LRParen { $2 }

table2:
  LVar LEq constant { [($1,$3)] }
| LVar LEq constant table2 { ($1,$3)::$4 }

formula:
  constant { Const($1) }
| LVar { Var($1) }
| LNot formula { Not($2) }
| LLParen formula LOr      formula LRParen { Or($2,$4) }
| LLParen formula LAnd     formula LRParen { And($2,$4) }
| LLParen formula LImplies formula LRParen { Implies($2,$4) }
| LLParen formula LIff     formula LRParen { Iff($2,$4) }

program:
  table formula LEof { ($1,$2) }
